#include "kb_server.h"
#include <errno.h>
#define NET_LINES 6500
#define PBM_LINES 1000
#define MAX_SPOT_AGE 1800
static int sockfd = -1;
static gint net_num = -1;
static gchar net_array[NET_LINES][NET_LENGTH];
static gint packet_num = -1;
static gchar packet_array[12][77] = {"", "", "", "", "", "",
                                     "", "", "", "", "", ""};
static gint ded_num = 0;
static gchar ded_array[6500][NET_LENGTH];
struct packet_bm_vars
{
  gint spot_num;
  gint spot_filter;
  gchar frequency[PBM_LINES][8];
  gchar call[PBM_LINES][14];
  gchar date[PBM_LINES][7];
  gchar time[PBM_LINES][7];
};
static struct packet_bm_vars pbm = {.spot_num = -1, .spot_filter = FALSE};
static void start_client(void);
static void alarm_handler(gint sig);
static gint run_client(void* none);
static void process_network_command(void);
static void work_from_network(const gchar *msg_line, gint na_num);
static gint delete_from_network(const gchar *msg_line);
static gint edit_from_network(void);
static void send_to_server(const gchar *contest_line, const gchar *cmd_type);
static void sort_cr_array(void);
static void network_message_box(const gchar *message_line, gint iclear);
static void send_msg_box(void);
static gint smb_key_handler(GtkWidget *widget, GdkEventKey *event,
                            SMBVars *smbd);
static gint smb_cursor(gpointer data);
static void send_packet_box(const gchar *spb_line, gint spb_spot);
static gint spb_key_handler(GtkWidget *widget, GdkEventKey *event,
                            SMBVars *spbd);
static gint spb_cursor(gpointer data);
static gint filter_spot(void);
static gushort set_server_port();
static void send_bandmap_box(const gchar *sbb_line);
static gint sbb_key_handler(GtkWidget *widget, GdkEventKey *event,
                            SMBVars *sbbd);
static gint sbb_cursor(gpointer data);
